package org.apache.bcel.classfile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Objects;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.classfile.Visitor;

public final class ConstantUtf8 extends Constant {
  private static volatile int considered;
  
  private static volatile int created;
  
  private static volatile int hits;
  
  private static volatile int skipped;
  
  private static final String SYS_PROP_CACHE_MAX_ENTRIES = "bcel.maxcached";
  
  private static final String SYS_PROP_CACHE_MAX_ENTRY_SIZE = "bcel.maxcached.size";
  
  private static final String SYS_PROP_STATISTICS = "bcel.statistics";
  
  private final String value;
  
  static {
    if (Cache.access$100())
      Runtime.getRuntime().addShutdownHook(new Thread(org.apache.bcel.classfile.ConstantUtf8::printStats)); 
  }
  
  public static synchronized void clearCache() {
    Cache.access$200().clear();
  }
  
  static synchronized void clearStats() {
    hits = considered = skipped = created = 0;
  }
  
  public static org.apache.bcel.classfile.ConstantUtf8 getCachedInstance(String value) {
    if (value.length() > Cache.access$300()) {
      skipped++;
      return new org.apache.bcel.classfile.ConstantUtf8(value);
    } 
    considered++;
    synchronized (org.apache.bcel.classfile.ConstantUtf8.class) {
      org.apache.bcel.classfile.ConstantUtf8 result = (org.apache.bcel.classfile.ConstantUtf8)Cache.access$200().get(value);
      if (result != null) {
        hits++;
        return result;
      } 
      result = new org.apache.bcel.classfile.ConstantUtf8(value);
      Cache.access$200().put(value, result);
      return result;
    } 
  }
  
  public static org.apache.bcel.classfile.ConstantUtf8 getInstance(DataInput dataInput) throws IOException {
    return getInstance(dataInput.readUTF());
  }
  
  public static org.apache.bcel.classfile.ConstantUtf8 getInstance(String value) {
    return Cache.isEnabled() ? getCachedInstance(value) : new org.apache.bcel.classfile.ConstantUtf8(value);
  }
  
  static void printStats() {
    String prefix = "[Apache Commons BCEL]";
    System.err.printf("%s Cache hit %,d/%,d, %d skipped.%n", new Object[] { "[Apache Commons BCEL]", Integer.valueOf(hits), Integer.valueOf(considered), Integer.valueOf(skipped) });
    System.err.printf("%s Total of %,d ConstantUtf8 objects created.%n", new Object[] { "[Apache Commons BCEL]", Integer.valueOf(created) });
    System.err.printf("%s Configuration: %s=%,d, %s=%,d.%n", new Object[] { "[Apache Commons BCEL]", "bcel.maxcached", Integer.valueOf(Cache.access$000()), "bcel.maxcached.size", 
          Integer.valueOf(Cache.access$300()) });
  }
  
  public ConstantUtf8(org.apache.bcel.classfile.ConstantUtf8 constantUtf8) {
    this(constantUtf8.getBytes());
  }
  
  ConstantUtf8(DataInput dataInput) throws IOException {
    super((byte)1);
    this.value = dataInput.readUTF();
    created++;
  }
  
  public ConstantUtf8(String value) {
    super((byte)1);
    this.value = Objects.<String>requireNonNull(value, "value");
    created++;
  }
  
  public void accept(Visitor v) {
    v.visitConstantUtf8(this);
  }
  
  public void dump(DataOutputStream file) throws IOException {
    file.writeByte(getTag());
    file.writeUTF(this.value);
  }
  
  public String getBytes() {
    return this.value;
  }
  
  @Deprecated
  public void setBytes(String bytes) {
    throw new UnsupportedOperationException();
  }
  
  public String toString() {
    return super.toString() + "(\"" + Utility.replace(this.value, "\n", "\\n") + "\")";
  }
}
